
/*  A Bison parser, made from parser.y with Bison version GNU Bison version 1.22
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	OR	258
#define	AND	259
#define	EQUALS	260
#define	NEQUAL	261
#define	LT_EQ	262
#define	GT_EQ	263
#define	LSHIFT	264
#define	RSHIFT	265
#define	UNARY	266
#define	NAME	267
#define	INTEGER	268
#define	DOUBLE	269
#define	BOOLEAN	270
#define	TIME	271
#define	SIN	272
#define	COS	273
#define	TAN	274
#define	POW	275
#define	EXP	276
#define	LOG	277
#define	LOG10	278
#define	SQRT	279
#define	HYPOT	280
#define	FLOOR	281
#define	CEIL	282
#define	FMOD	283
#define	FABS	284
#define	ANALYSIS_TYPE	285
#define	DIRECTION	286
#define	CONSTRAINT	287
#define	HINGED	288
#define	NODE_DOF	289
#define	MASS_MODE	290
#define	PROBLEM	291
#define	NODES	292
#define	ELEMENTS	293
#define	MATERIALS	294
#define	LOADS	295
#define	FORCES	296
#define	CONSTRAINTS	297
#define	ANALYSIS	298
#define	END	299
#define	TITLE_EQ	300
#define	NODES_EQ	301
#define	ELEMENTS_EQ	302
#define	ANALYSIS_EQ	303
#define	X_EQ	304
#define	Y_EQ	305
#define	Z_EQ	306
#define	FORCE_EQ	307
#define	CONSTRAINT_EQ	308
#define	MASS_EQ	309
#define	LOAD_EQ	310
#define	MATERIAL_EQ	311
#define	E_EQ	312
#define	IX_EQ	313
#define	IY_EQ	314
#define	IZ_EQ	315
#define	A_EQ	316
#define	J_EQ	317
#define	G_EQ	318
#define	T_EQ	319
#define	RHO_EQ	320
#define	NU_EQ	321
#define	KAPPA_EQ	322
#define	RK_EQ	323
#define	RM_EQ	324
#define	KX_EQ	325
#define	KY_EQ	326
#define	KZ_EQ	327
#define	C_EQ	328
#define	DIRECTION_EQ	329
#define	VALUES_EQ	330
#define	FX_EQ	331
#define	FY_EQ	332
#define	FZ_EQ	333
#define	MX_EQ	334
#define	MY_EQ	335
#define	MZ_EQ	336
#define	SFX_EQ	337
#define	SFY_EQ	338
#define	SFZ_EQ	339
#define	SMX_EQ	340
#define	SMY_EQ	341
#define	SMZ_EQ	342
#define	TX_EQ	343
#define	TY_EQ	344
#define	TZ_EQ	345
#define	RX_EQ	346
#define	RY_EQ	347
#define	RZ_EQ	348
#define	ITX_EQ	349
#define	ITY_EQ	350
#define	ITZ_EQ	351
#define	IRX_EQ	352
#define	IRY_EQ	353
#define	IRZ_EQ	354
#define	VX_EQ	355
#define	VY_EQ	356
#define	VZ_EQ	357
#define	AX_EQ	358
#define	AY_EQ	359
#define	AZ_EQ	360
#define	ALPHA_EQ	361
#define	BETA_EQ	362
#define	GAMMA_EQ	363
#define	DOFS_EQ	364
#define	MASS_MODE_EQ	365
#define	START_EQ	366
#define	STOP_EQ	367
#define	STEP_EQ	368
#define	CANVAS	369
#define	FIGURES	370
#define	NODE_NUM_EQ	371
#define	ELT_NUM_EQ	372
#define	SNAP_EQ	373
#define	GRID_EQ	374
#define	SNAP_SIZE_EQ	375
#define	GRID_SIZE_EQ	376
#define	X_MIN_EQ	377
#define	X_MAX_EQ	378
#define	Y_MIN_EQ	379
#define	Y_MAX_EQ	380
#define	SCALE_EQ	381
#define	X_POS_EQ	382
#define	Y_POS_EQ	383
#define	WIDTH_EQ	384
#define	HEIGHT_EQ	385
#define	NODE_COLOR_EQ	386
#define	ELT_COLOR_EQ	387
#define	LABEL_FONT_EQ	388
#define	TOOL_COLOR_EQ	389
#define	TOOL_FONT_EQ	390
#define	FONT_EQ	391
#define	COLOR_EQ	392
#define	LENGTH_EQ	393
#define	TEXT_EQ	394
#define	POINTS_EQ	395
#define	FIGURE_TYPE	396

#line 1 "parser.y"

/*
    This file is part of the FElt finite element analysis package.
    Copyright (C) 1993-1995 Jason I. Gobat and Darren C. Atkinson

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/************************************************************************
 * File:	parser.y						*
 *									*
 * Description:	This file contains the yacc specification for the	*
 *		parser for the FElt 2.0 system.				*
 ************************************************************************/

# include <stdio.h>
# include "code.h"
# include "error.h"
# include "objects.h"
# include "problem.h"
# include "allocate.h"

# if !defined (__GNUC__) && !defined (__sparc__)
# define alloca malloc		/* prevents alloca from being called */
# endif

# define VariableExpression 2	/* not 0, 1, or, 'h' */

extern void yyerror ( );
extern int  yylex  ( );
extern char *strdup ( );


/* Last parameters (default for some parameters is to inherit the last). */

static double		  last_x;		/* last x coordinate	   */
static double		  last_y;		/* last y coordinate	   */
static double		  last_z;		/* last z coordinate	   */
static char		 *last_constraint;	/* name of last constraint */
static char		 *last_material;	/* name of last material   */



/* Current objects (inherited attributes). */

static Item		  found;		/* current object	   */
static Node		  node;			/* current node		   */
static Element		  element;		/* current element	   */
static Material		  material;		/* current material	   */
static Distributed	  load;			/* current load		   */
static Force		  force;		/* current force	   */
static Constraint	  constraint;		/* current constraint	   */
static Definition	  definition;		/* current definition	   */


/* Dummy strucutures.  If an object is defined twice, the second definition
   is illegal and the current object is set to a dummy object. */

static struct node	  dummy_node;		/* dummy node		   */
static struct element	  dummy_element;	/* dummy element	   */
static struct material	  dummy_material;	/* dummy material	   */
static struct distributed dummy_load;		/* dummy distributed load  */
static struct force	  dummy_force;		/* dummy force		   */
static struct constraint  dummy_constraint;	/* dummy constraint	   */


/* Temporary arrays. */

static int		  int_array [1024];	/* temporary integer array */
static int		 *int_ptr;		/* pointer into array	   */
static Pair		  pair_array [1024];	/* temporary pair array	   */
static Pair		 *pair_ptr;		/* pointer into array	   */


/* Discrete expression variables. */

static int		  table_error = 0;	/* error indicator	   */
static double		  last_time = 0;	/* last time coordinate	   */
static double		 *table = NULL;		/* table of values	   */
static unsigned		  table_count = 0;	/* count of values	   */
static unsigned		  table_size = 0;	/* size of table	   */


/* Figure list variables. */

static float		  figure_x;		/* current x-coordinate	   */
static float		  figure_y;		/* current y-coordinate	   */
static unsigned		  figure_size;		/* size of figure list	   */
static unsigned		  fig_point_size;	/* size of point list	   */
static FigInfo		 *figure;		/* current figure	   */

#line 105 "parser.y"
typedef union {
    int       i;
    double    d;
    char     *s;
    Pair      p;
    char      c;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		507
#define	YYFLAG		-32768
#define	YYNTBASE	161

#define YYTRANSLATE(x) ((unsigned)(x) <= 396 ? yytranslate[x] : 242)

static const short yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    24,     2,     2,     2,    22,     9,     2,   156,
   157,    20,    18,   160,    19,     2,    21,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     4,     2,    12,
     2,    13,     3,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
   158,     2,   159,     8,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     7,     2,    25,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     5,     6,    10,
    11,    14,    15,    16,    17,    23,    26,    27,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
    40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
    50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
    60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
   100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
   110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
   130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
   140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
   150,   151,   152,   153,   154,   155
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     5,     9,    10,    13,    14,    17,    18,    21,    24,
    27,    30,    32,    35,    36,    38,    40,    42,    44,    46,
    48,    50,    52,    54,    56,    59,    62,    63,    66,    68,
    70,    74,    77,    78,    81,    84,    87,    90,    93,    96,
    98,   101,   103,   106,   107,   110,   112,   114,   118,   121,
   122,   127,   130,   133,   135,   139,   142,   144,   146,   150,
   153,   155,   158,   161,   162,   165,   167,   170,   171,   174,
   177,   180,   183,   186,   189,   192,   195,   198,   201,   204,
   207,   210,   213,   216,   219,   222,   225,   227,   230,   233,
   234,   237,   239,   242,   243,   246,   249,   252,   254,   258,
   261,   263,   269,   274,   277,   280,   281,   284,   286,   289,
   290,   293,   297,   301,   305,   309,   313,   317,   321,   325,
   329,   333,   337,   341,   343,   346,   349,   350,   353,   355,
   358,   359,   362,   366,   370,   374,   378,   382,   386,   389,
   392,   395,   398,   401,   404,   407,   410,   413,   416,   419,
   422,   424,   426,   428,   430,   432,   434,   437,   440,   441,
   444,   447,   450,   453,   456,   459,   462,   465,   470,   475,
   478,   480,   484,   487,   488,   492,   495,   496,   499,   502,
   503,   506,   509,   512,   515,   518,   521,   524,   527,   530,
   533,   536,   539,   542,   545,   548,   551,   554,   557,   560,
   563,   566,   568,   571,   572,   575,   577,   580,   581,   584,
   587,   590,   593,   596,   599,   602,   605,   608,   613,   617,
   620,   621,   627,   629,   631,   634,   638,   641,   643,   649,
   650,   652,   660,   665,   670,   674,   678,   682,   686,   690,
   694,   698,   702,   706,   710,   714,   718,   722,   726,   730,
   734,   737,   740,   743,   746,   750,   752,   754,   756,   758,
   763,   768,   773,   780,   785,   790,   795,   800,   807,   812,
   817,   824,   829,   830,   831,   832
};

static const short yyrhs[] = {   162,
   163,   166,    58,     0,    63,   231,    58,     0,     0,    50,
   164,     0,     0,   164,   165,     0,     0,    59,    26,     0,
    60,    27,     0,    61,    27,     0,    62,    44,     0,     1,
     0,   166,   167,     0,     0,   168,     0,   175,     0,   186,
     0,   192,     0,   200,     0,   206,     0,   214,     0,   219,
     0,   222,     0,    58,     0,    51,   169,     0,   169,   170,
     0,     0,   171,   173,     0,   172,     0,    27,     0,   156,
   235,   157,     0,   173,   174,     0,     0,    63,   235,     0,
    64,   235,     0,    65,   235,     0,    68,   235,     0,    66,
    26,     0,    67,    26,     0,     1,     0,   176,   177,     0,
    52,     0,   177,   178,     0,     0,   179,   181,     0,   180,
     0,    27,     0,   156,   235,   157,     0,   181,   182,     0,
     0,    60,   158,   183,   159,     0,    70,    26,     0,    69,
   185,     0,     1,     0,   183,   160,   184,     0,   183,   184,
     0,   184,     0,   172,     0,   185,   160,    26,     0,   185,
    26,     0,    26,     0,    53,   187,     0,   187,   188,     0,
     0,   189,   190,     0,    26,     0,   190,   191,     0,     0,
   151,    26,     0,    71,   235,     0,    72,   235,     0,    73,
   235,     0,    74,   235,     0,    75,   235,     0,    76,   235,
     0,    77,   235,     0,    78,   235,     0,    79,   235,     0,
    80,   235,     0,    81,   235,     0,    82,   235,     0,    83,
   235,     0,    84,   235,     0,    85,   235,     0,    86,   235,
     0,    87,   235,     0,     1,     0,    54,   193,     0,   193,
   194,     0,     0,   195,   196,     0,    26,     0,   196,   197,
     0,     0,   151,    26,     0,    88,    45,     0,    89,   198,
     0,     1,     0,   198,   160,   199,     0,   198,   199,     0,
   199,     0,   156,   172,   160,   235,   157,     0,   156,   172,
   235,   157,     0,    55,   201,     0,   201,   202,     0,     0,
   203,   204,     0,    26,     0,   204,   205,     0,     0,   151,
    26,     0,    90,   234,   231,     0,    91,   234,   231,     0,
    92,   234,   231,     0,    93,   234,   231,     0,    94,   234,
   231,     0,    95,   234,   231,     0,    96,   234,   231,     0,
    97,   234,   231,     0,    98,   234,   231,     0,    99,   234,
   231,     0,   100,   234,   231,     0,   101,   234,   231,     0,
     1,     0,    56,   207,     0,   207,   208,     0,     0,   209,
   210,     0,    26,     0,   210,   211,     0,     0,   151,    26,
     0,   102,   234,   212,     0,   103,   234,   212,     0,   104,
   234,   212,     0,   105,   234,   213,     0,   106,   234,   213,
     0,   107,   234,   213,     0,   108,   235,     0,   109,   235,
     0,   110,   235,     0,   111,   235,     0,   112,   235,     0,
   113,   235,     0,   114,   235,     0,   115,   235,     0,   116,
   235,     0,   117,   235,     0,   118,   235,     0,   119,   235,
     0,     1,     0,   231,     0,    46,     0,   231,     0,    46,
     0,    47,     0,    57,   215,     0,   215,   216,     0,     0,
   120,   235,     0,   121,   235,     0,   122,   235,     0,    82,
   235,     0,    83,   235,     0,   125,   235,     0,   127,   235,
     0,   126,   235,     0,    60,   158,   217,   159,     0,   123,
   158,   218,   159,     0,   124,    49,     0,     1,     0,   217,
   160,   172,     0,   217,   172,     0,     0,   218,   160,    48,
     0,   218,    48,     0,     0,   128,   220,     0,   220,   221,
     0,     0,   130,    29,     0,   131,    29,     0,   132,    29,
     0,   133,    29,     0,   134,   235,     0,   135,   235,     0,
   136,   235,     0,   137,   235,     0,   138,   235,     0,   139,
   235,     0,   141,   235,     0,   142,   235,     0,   143,   235,
     0,   144,   235,     0,   140,   235,     0,   145,    26,     0,
   146,    26,     0,   147,    26,     0,   148,    26,     0,   149,
    26,     0,   223,   224,     0,   129,     0,   224,   225,     0,
     0,   226,   227,     0,   155,     0,   227,   228,     0,     0,
    63,   235,     0,    64,   235,     0,   143,   235,     0,   144,
   235,     0,   125,   235,     0,   152,   235,     0,   153,    26,
     0,   151,    26,     0,   150,    26,     0,   154,   158,   229,
   159,     0,   229,   160,   230,     0,   229,   230,     0,     0,
   156,   235,   160,   235,   157,     0,   236,     0,   232,     0,
   232,    18,     0,   232,   160,   233,     0,   232,   233,     0,
   233,     0,   156,   235,   160,   235,   157,     0,     0,   236,
     0,   236,     3,   238,   236,     4,   239,   236,     0,   236,
     5,   240,   236,     0,   236,     6,   241,   236,     0,   236,
     7,   236,     0,   236,     8,   236,     0,   236,     9,   236,
     0,   236,    10,   236,     0,   236,    11,   236,     0,   236,
    12,   236,     0,   236,    13,   236,     0,   236,    14,   236,
     0,   236,    15,   236,     0,   236,    16,   236,     0,   236,
    17,   236,     0,   236,    18,   236,     0,   236,    19,   236,
     0,   236,    20,   236,     0,   236,    21,   236,     0,   236,
    22,   236,     0,    18,   236,     0,    19,   236,     0,    24,
   236,     0,    25,   236,     0,   156,   236,   157,     0,    27,
     0,    28,     0,    30,     0,   237,     0,    31,   156,   236,
   157,     0,    32,   156,   236,   157,     0,    33,   156,   236,
   157,     0,    34,   156,   236,   160,   236,   157,     0,    35,
   156,   236,   157,     0,    36,   156,   236,   157,     0,    37,
   156,   236,   157,     0,    38,   156,   236,   157,     0,    39,
   156,   236,   160,   236,   157,     0,    40,   156,   236,   157,
     0,    41,   156,   236,   157,     0,    42,   156,   236,   160,
   236,   157,     0,    43,   156,   236,   157,     0,     0,     0,
     0,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   173,   174,   179,   193,   194,   199,   200,   205,   211,   216,
   221,   226,   233,   234,   239,   240,   241,   242,   243,   244,
   245,   246,   247,   248,   255,   260,   261,   266,   271,   299,
   300,   306,   307,   312,   317,   322,   327,   332,   338,   343,
   350,   355,   366,   367,   372,   377,   402,   403,   409,   410,
   415,   437,   442,   444,   449,   454,   459,   468,   477,   490,
   503,   516,   521,   522,   527,   532,   546,   547,   552,   558,
   563,   568,   573,   578,   583,   588,   593,   598,   603,   608,
   613,   618,   623,   628,   633,   638,   643,   650,   655,   656,
   661,   666,   681,   682,   687,   693,   698,   719,   724,   729,
   734,   743,   752,   766,   771,   772,   777,   782,   797,   798,
   803,   809,   814,   819,   824,   829,   834,   839,   844,   849,
   854,   859,   864,   869,   876,   881,   882,   887,   892,   907,
   908,   913,   919,   929,   939,   949,   959,   969,   979,   984,
   989,   994,   999,  1004,  1009,  1014,  1019,  1024,  1029,  1034,
  1039,  1044,  1049,  1057,  1062,  1067,  1077,  1082,  1083,  1088,
  1093,  1098,  1103,  1108,  1113,  1118,  1123,  1128,  1143,  1154,
  1159,  1164,  1169,  1174,  1182,  1187,  1192,  1206,  1211,  1212,
  1217,  1222,  1227,  1232,  1237,  1242,  1247,  1252,  1257,  1262,
  1267,  1272,  1277,  1282,  1287,  1292,  1298,  1304,  1310,  1316,
  1327,  1332,  1340,  1341,  1346,  1351,  1377,  1378,  1383,  1388,
  1393,  1398,  1403,  1408,  1413,  1419,  1425,  1431,  1436,  1449,
  1462,  1475,  1486,  1492,  1506,  1523,  1524,  1525,  1530,  1551,
  1559,  1569,  1580,  1590,  1600,  1606,  1612,  1618,  1624,  1630,
  1636,  1642,  1648,  1654,  1660,  1666,  1672,  1678,  1684,  1690,
  1696,  1701,  1707,  1713,  1719,  1724,  1730,  1736,  1742,  1747,
  1753,  1759,  1765,  1771,  1777,  1783,  1789,  1795,  1801,  1807,
  1813,  1819,  1828,  1837,  1846,  1857
};

static const char * const yytname[] = {   "$","error","$illegal.","'?'","':'",
"OR","AND","'|'","'^'","'&'","EQUALS","NEQUAL","'<'","'>'","LT_EQ","GT_EQ","LSHIFT",
"RSHIFT","'+'","'-'","'*'","'/'","'%'","UNARY","'!'","'~'","NAME","INTEGER",
"DOUBLE","BOOLEAN","TIME","SIN","COS","TAN","POW","EXP","LOG","LOG10","SQRT",
"HYPOT","FLOOR","CEIL","FMOD","FABS","ANALYSIS_TYPE","DIRECTION","CONSTRAINT",
"HINGED","NODE_DOF","MASS_MODE","PROBLEM","NODES","ELEMENTS","MATERIALS","LOADS",
"FORCES","CONSTRAINTS","ANALYSIS","END","TITLE_EQ","NODES_EQ","ELEMENTS_EQ",
"ANALYSIS_EQ","X_EQ","Y_EQ","Z_EQ","FORCE_EQ","CONSTRAINT_EQ","MASS_EQ","LOAD_EQ",
"MATERIAL_EQ","E_EQ","IX_EQ","IY_EQ","IZ_EQ","A_EQ","J_EQ","G_EQ","T_EQ","RHO_EQ",
"NU_EQ","KAPPA_EQ","RK_EQ","RM_EQ","KX_EQ","KY_EQ","KZ_EQ","C_EQ","DIRECTION_EQ",
"VALUES_EQ","FX_EQ","FY_EQ","FZ_EQ","MX_EQ","MY_EQ","MZ_EQ","SFX_EQ","SFY_EQ",
"SFZ_EQ","SMX_EQ","SMY_EQ","SMZ_EQ","TX_EQ","TY_EQ","TZ_EQ","RX_EQ","RY_EQ",
"RZ_EQ","ITX_EQ","ITY_EQ","ITZ_EQ","IRX_EQ","IRY_EQ","IRZ_EQ","VX_EQ","VY_EQ",
"VZ_EQ","AX_EQ","AY_EQ","AZ_EQ","ALPHA_EQ","BETA_EQ","GAMMA_EQ","DOFS_EQ","MASS_MODE_EQ",
"START_EQ","STOP_EQ","STEP_EQ","CANVAS","FIGURES","NODE_NUM_EQ","ELT_NUM_EQ",
"SNAP_EQ","GRID_EQ","SNAP_SIZE_EQ","GRID_SIZE_EQ","X_MIN_EQ","X_MAX_EQ","Y_MIN_EQ",
"Y_MAX_EQ","SCALE_EQ","X_POS_EQ","Y_POS_EQ","WIDTH_EQ","HEIGHT_EQ","NODE_COLOR_EQ",
"ELT_COLOR_EQ","LABEL_FONT_EQ","TOOL_COLOR_EQ","TOOL_FONT_EQ","FONT_EQ","COLOR_EQ",
"LENGTH_EQ","TEXT_EQ","POINTS_EQ","FIGURE_TYPE","'('","')'","'['","']'","','",
"specification","initialize","problem_description","problem_parameter_list",
"problem_parameter","section_list","section","node_section","node_definition_list",
"node_definition","node_number","node_number_expression","node_parameter_list",
"node_parameter","element_section","element_header","element_definition_list",
"element_definition","element_number","element_number_expression","element_parameter_list",
"element_parameter","element_node_list","element_node","element_load_list","material_section",
"material_definition_list","material_definition","material_name","material_parameter_list",
"material_parameter","load_section","load_definition_list","load_definition",
"load_name","load_parameter_list","load_parameter","value_pair_list","value_pair",
"force_section","force_definition_list","force_definition","force_name","force_parameter_list",
"force_parameter","constraint_section","constraint_definition_list","constraint_definition",
"constraint_name","constraint_parameter_list","constraint_parameter","translation",
"rotation","analysis_section","analysis_parameter_list","analysis_parameter",
"analysis_node_list","analysis_dof_list","canvas_section","canvas_parameter_list",
"canvas_parameter","figure_section","figure_header","figure_definition_list",
"figure_definition","figure_type","figure_parameter_list","figure_parameter",
"figure_pair_list","figure_pair","variable_expression","discrete_pair_list",
"discrete_pair","enable_copy","constant_expression","expression","function",
"if_action","else_action","or_action","and_action",""
};
#endif

static const short yyr1[] = {     0,
   161,   161,   162,   163,   163,   164,   164,   165,   165,   165,
   165,   165,   166,   166,   167,   167,   167,   167,   167,   167,
   167,   167,   167,   167,   168,   169,   169,   170,   171,   172,
   172,   173,   173,   174,   174,   174,   174,   174,   174,   174,
   175,   176,   177,   177,   178,   179,   180,   180,   181,   181,
   182,   182,   182,   182,   183,   183,   183,   184,   185,   185,
   185,   186,   187,   187,   188,   189,   190,   190,   191,   191,
   191,   191,   191,   191,   191,   191,   191,   191,   191,   191,
   191,   191,   191,   191,   191,   191,   191,   192,   193,   193,
   194,   195,   196,   196,   197,   197,   197,   197,   198,   198,
   198,   199,   199,   200,   201,   201,   202,   203,   204,   204,
   205,   205,   205,   205,   205,   205,   205,   205,   205,   205,
   205,   205,   205,   205,   206,   207,   207,   208,   209,   210,
   210,   211,   211,   211,   211,   211,   211,   211,   211,   211,
   211,   211,   211,   211,   211,   211,   211,   211,   211,   211,
   211,   212,   212,   213,   213,   213,   214,   215,   215,   216,
   216,   216,   216,   216,   216,   216,   216,   216,   216,   216,
   216,   217,   217,   217,   218,   218,   218,   219,   220,   220,
   221,   221,   221,   221,   221,   221,   221,   221,   221,   221,
   221,   221,   221,   221,   221,   221,   221,   221,   221,   221,
   222,   223,   224,   224,   225,   226,   227,   227,   228,   228,
   228,   228,   228,   228,   228,   228,   228,   228,   229,   229,
   229,   230,   231,   231,   231,   232,   232,   232,   233,   234,
   235,   236,   236,   236,   236,   236,   236,   236,   236,   236,
   236,   236,   236,   236,   236,   236,   236,   236,   236,   236,
   236,   236,   236,   236,   236,   236,   236,   236,   236,   237,
   237,   237,   237,   237,   237,   237,   237,   237,   237,   237,
   237,   237,   238,   239,   240,   241
};

static const short yyr2[] = {     0,
     4,     3,     0,     2,     0,     2,     0,     2,     2,     2,
     2,     1,     2,     0,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     2,     2,     0,     2,     1,     1,
     3,     2,     0,     2,     2,     2,     2,     2,     2,     1,
     2,     1,     2,     0,     2,     1,     1,     3,     2,     0,
     4,     2,     2,     1,     3,     2,     1,     1,     3,     2,
     1,     2,     2,     0,     2,     1,     2,     0,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     1,     2,     2,     0,
     2,     1,     2,     0,     2,     2,     2,     1,     3,     2,
     1,     5,     4,     2,     2,     0,     2,     1,     2,     0,
     2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     1,     2,     2,     0,     2,     1,     2,
     0,     2,     3,     3,     3,     3,     3,     3,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     1,     1,     1,     1,     1,     1,     2,     2,     0,     2,
     2,     2,     2,     2,     2,     2,     2,     4,     4,     2,
     1,     3,     2,     0,     3,     2,     0,     2,     2,     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     1,     2,     0,     2,     1,     2,     0,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     4,     3,     2,
     0,     5,     1,     1,     2,     3,     2,     1,     5,     0,
     1,     7,     4,     4,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     2,     2,     2,     2,     3,     1,     1,     1,     1,     4,
     4,     4,     6,     4,     4,     4,     4,     6,     4,     4,
     6,     4,     0,     0,     0,     0
};

static const short yydefact[] = {     3,
     0,     5,     0,     0,     0,     0,   256,   257,   258,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   224,   228,   223,   259,     7,    14,
     0,   251,   252,   253,   254,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   231,
     2,   225,     0,     0,   227,   273,   275,   276,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   255,   231,   226,     0,     0,     0,   235,   236,   237,
   238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
   248,   249,   250,    12,     0,     0,     0,     0,     6,    27,
    42,    64,    90,   106,   127,   159,    24,   180,   202,    13,
    15,    16,    44,    17,    18,    19,    20,    21,    22,    23,
   204,   260,   261,   262,     0,   264,   265,   266,   267,     0,
   269,   270,     0,   272,     0,     0,   233,   234,     8,     9,
    10,    11,    25,    62,    88,   104,   125,     0,   178,    41,
   201,     0,     0,     0,   229,   274,    30,     0,    26,    33,
    29,    66,    63,    68,    92,    89,    94,   108,   105,   110,
   129,   126,   131,   171,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   158,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   179,    47,     0,    43,
    50,    46,   206,   203,   208,   263,   268,   271,     0,     0,
     0,     0,     0,     0,     0,   174,   163,   164,   160,   161,
   162,   177,   170,   165,   167,   166,   181,   182,   183,   184,
   185,   186,   187,   188,   189,   190,   195,   191,   192,   193,
   194,   196,   197,   198,   199,   200,     0,     0,   205,   232,
    31,    40,     0,     0,     0,     0,     0,     0,    32,    87,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    67,    98,
     0,     0,     0,    93,   124,   230,   230,   230,   230,   230,
   230,   230,   230,   230,   230,   230,   230,     0,   109,   151,
   230,   230,   230,   230,   230,   230,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   130,
     0,     0,    48,    54,     0,     0,     0,    49,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   207,    34,
    35,    36,    38,    39,    37,    70,    71,    72,    73,    74,
    75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
    85,    86,    69,    96,     0,    97,   101,    95,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   111,     0,     0,     0,     0,     0,     0,   139,   140,   141,
   142,   143,   144,   145,   146,   147,   148,   149,   150,   132,
   168,     0,   173,   176,   169,     0,     0,    61,    53,    52,
   209,   210,   213,   211,   212,   217,   216,   214,   215,   221,
     0,     0,   100,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   153,   133,   152,   134,   135,
   155,   156,   136,   154,   137,   138,   172,   175,    58,     0,
    57,    60,     0,     0,     0,     0,    99,    51,     0,    56,
    59,     0,   218,     0,   220,     0,   103,    55,     0,   219,
   102,     0,     0,   222,     0,     0,     0
};

static const short yydefgoto[] = {   505,
     2,    30,    75,   119,    76,   130,   131,   163,   179,   180,
   479,   241,   289,   132,   133,   170,   230,   231,   232,   278,
   358,   480,   481,   439,   134,   164,   183,   184,   242,   309,
   135,   165,   186,   187,   243,   314,   396,   397,   136,   166,
   189,   190,   244,   329,   137,   167,   192,   193,   245,   350,
   467,   473,   138,   168,   206,   351,   352,   139,   169,   227,
   140,   141,   171,   234,   235,   279,   369,   484,   495,   468,
    25,    26,   399,    49,    93,    28,    95,   239,    96,    97
};

static const short yypact[] = {   -42,
  1104,   -26,  1130,  1130,  1130,  1130,-32768,-32768,-32768,  -128,
  -127,  -122,  -107,  -105,  -103,  -101,  -100,   -99,   -81,   -45,
   -23,   -22,  1130,    72,   -10,-32768,  1230,-32768,-32768,-32768,
  1130,-32768,-32768,-32768,-32768,  1130,  1130,  1130,  1130,  1130,
  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,   -25,   460,
-32768,-32768,  1130,   -11,-32768,-32768,-32768,-32768,  1130,  1130,
  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,
  1130,  1130,  1130,  1130,   220,   711,   460,   480,   500,   520,
    71,   540,   560,   580,   613,   107,   633,   653,   187,   673,
  1130,-32768,  1230,-32768,  1130,  1130,  1130,  1295,   375,   593,
   324,   324,    81,    81,    81,    81,    87,    87,    11,    11,
-32768,-32768,-32768,-32768,   110,   120,   121,   109,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   151,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,  1130,-32768,-32768,-32768,-32768,  1130,
-32768,-32768,  1130,-32768,    -3,   991,   957,  1280,-32768,-32768,
-32768,-32768,   -17,   135,   139,   140,   141,  1149,  1080,   -13,
    13,   693,   713,   733,-32768,-32768,-32768,  1130,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,    24,  1130,  1130,  1130,  1130,  1130,
    29,   134,  1130,  1130,  1130,-32768,   162,   189,   190,   191,
  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,
  1130,   143,   202,   203,   204,   206,-32768,-32768,  1130,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  1130,    77,
   159,   780,   904,   890,   770,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,    78,   308,   229,  1230,
-32768,-32768,  1130,  1130,  1130,   210,   211,  1130,-32768,-32768,
  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,
  1130,  1130,  1130,  1130,  1130,  1130,  1130,   213,-32768,-32768,
   195,    85,   219,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   222,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,  1130,  1130,  1130,  1130,
  1130,  1130,  1130,  1130,  1130,  1130,  1130,  1130,   223,-32768,
   -18,   -28,-32768,-32768,    88,   242,   243,-32768,  1130,  1130,
  1130,  1130,  1130,   257,   258,  1130,   259,   128,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,   -17,  -145,-32768,-32768,  1104,  1104,
  1104,  1104,  1104,  1104,  1104,  1104,  1104,  1104,  1104,  1104,
-32768,  1078,  1078,  1078,  1052,  1052,  1052,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   -17,-32768,-32768,-32768,   241,   -17,-32768,   -20,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  1026,    85,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    25,
-32768,-32768,   264,  -133,  1130,   137,-32768,-32768,   -17,-32768,
-32768,  1130,-32768,   152,-32768,   138,-32768,-32768,   131,-32768,
-32768,  1130,   153,-32768,   311,   312,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -162,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,  -473,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,  -348,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -401,  -399,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  -181,    18,
-32768,     0,   703,   -41,    -1,-32768,-32768,-32768,-32768,-32768
};


#define	YYLAST		1317


static const short yytable[] = {    27,
   181,    32,    33,    34,    35,   482,   490,    52,   177,   177,
   395,   469,   470,   228,   452,   498,   475,   476,    24,   434,
     1,    50,   492,    29,    55,   493,   494,    36,    37,    77,
    72,    73,    74,    38,    78,    79,    80,    81,    82,    83,
    84,    85,    86,    87,    88,    89,    90,   453,    39,   155,
    40,   177,    41,    94,    42,    43,    44,    98,    99,   100,
   101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
   111,   112,   113,    56,    45,    57,    58,    59,    60,    61,
    62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
    72,    73,    74,   156,   157,   158,    68,    69,    70,    71,
    72,    73,    74,   487,    70,    71,    72,    73,    74,    56,
    46,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    51,
   435,   436,    47,    48,    91,   159,   240,   178,   178,   483,
   431,   432,   229,   172,    53,    53,   160,   161,   173,    54,
    -1,   174,   162,   175,   247,   248,   249,   250,   251,   282,
   182,   254,   255,   256,   185,   188,   191,   233,   272,   261,
   262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
   178,   246,   253,   488,   489,   -28,   252,   277,   433,    56,
   257,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,   -28,
   -28,   -28,   -28,   -28,   -28,   -28,   -28,   258,   259,   260,
   114,   283,   284,   285,   286,   287,   288,   273,   274,   275,
   145,   276,   451,   281,   353,   373,   374,   280,   393,   394,
   395,   370,   371,   372,   398,   437,   375,   411,   430,   376,
   377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
   387,   388,   389,   390,   391,   392,   150,   438,   440,   477,
    -4,    -4,    -4,    -4,    -4,    -4,    -4,    -4,   115,   116,
   117,   118,   446,   447,   449,   450,   -28,   -28,   478,   491,
   502,   359,   360,   497,   501,   418,   419,   420,   421,   422,
   423,   424,   425,   426,   427,   428,   429,   492,   354,   504,
   506,   507,   500,     0,   -28,     0,     0,   441,   442,   443,
   444,   445,     0,     0,   448,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   -45,    64,    65,    66,    67,    68,
    69,    70,    71,    72,    73,    74,   153,    -4,    -4,     0,
     0,     0,     0,   361,     0,     0,     0,     0,   -45,   -45,
   -45,   -45,   -45,   -45,   -45,   -45,     0,   355,     0,     0,
     0,   362,   363,     0,     0,     0,   356,   357,   364,   365,
   366,   367,   368,    61,    62,    63,    64,    65,    66,    67,
    68,    69,    70,    71,    72,    73,    74,    27,    27,    27,
    27,    27,    27,    27,    27,    27,    27,    27,    27,   486,
    27,    27,    27,    27,    27,    27,   454,   455,   456,   457,
   458,   459,   460,   461,   462,   463,   464,   465,     0,     0,
     0,     0,   474,   474,   474,   -45,   -45,     0,     0,     0,
     0,     0,     0,   496,     0,     0,     0,     0,     0,     0,
   499,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   503,     0,    56,   -45,    57,    58,    59,    60,    61,    62,
    63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
    73,    74,    56,     0,    57,    58,    59,    60,    61,    62,
    63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
    73,    74,    56,     0,    57,    58,    59,    60,    61,    62,
    63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
    73,    74,    56,     0,    57,    58,    59,    60,    61,    62,
    63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
    73,    74,    56,     0,    57,    58,    59,    60,    61,    62,
    63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
    73,    74,    56,     0,    57,    58,    59,    60,    61,    62,
    63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
    73,    74,    56,     0,    57,    58,    59,    60,    61,    62,
    63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
    73,    74,    62,    63,    64,    65,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    56,    92,    57,    58,    59,
    60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    56,   142,    57,    58,    59,
    60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    56,   143,    57,    58,    59,
    60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    56,   144,    57,    58,    59,
    60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    56,   146,    57,    58,    59,
    60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    56,   147,    57,    58,    59,
    60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    56,   148,    57,    58,    59,
    60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
    70,    71,    72,    73,    74,     0,     0,     0,     0,     0,
     0,   120,   121,   122,   123,   124,   125,   126,   127,   149,
   330,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   290,     0,     0,     0,     0,     0,     0,     0,     0,   151,
     0,     0,     0,     0,     0,  -128,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   -65,     0,     0,     0,   152,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
  -128,  -128,  -128,  -128,  -128,  -128,  -128,  -128,     0,   154,
   -65,   -65,   -65,   -65,   -65,   -65,   -65,   -65,   128,   129,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   236,
   291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
   301,   302,   303,   304,   305,   306,   307,     0,     0,   237,
     0,   331,   332,   333,   334,   335,   336,   337,   338,   339,
   340,   341,   342,   343,   344,   345,   346,   347,   348,   238,
   315,     0,     0,     0,     0,     0,     0,  -128,  -128,     0,
     0,     0,     0,     0,   310,     0,     0,   -65,   -65,     0,
     0,     0,     0,     0,     0,  -107,     0,     0,     0,     0,
   349,     0,     0,     0,     0,     0,     0,     0,     0,   -91,
   308,     0,     0,     0,     0,     0,     0,     0,     0,     0,
  -107,  -107,  -107,  -107,  -107,  -107,  -107,  -107,     0,     0,
     0,     0,     0,     0,   -91,   -91,   -91,   -91,   -91,   -91,
   -91,   -91,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,   316,
   317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
   327,   311,   312,    56,   176,    57,    58,    59,    60,    61,
    62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
    72,    73,    74,     0,     0,     0,     0,  -107,  -107,   400,
   401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     0,   -91,   -91,   412,   413,   414,   415,   416,   417,     0,
   328,     0,     0,     3,     4,     0,     0,     0,     0,     5,
     6,     0,     7,     8,   313,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,     3,
     4,     0,     0,     0,     0,     5,     6,     0,     7,     8,
     0,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,     3,     4,   471,   472,     0,
     0,     5,     6,     0,     7,     8,     0,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,     3,     4,   466,     0,     0,     0,     5,     6,     0,
     7,     8,     0,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,     3,     4,   194,
     0,     0,     0,     5,     6,     0,     7,     8,     0,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,     0,     0,     0,     0,     0,     0,     0,
     0,    31,     0,     0,     0,   485,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,  -157,
  -157,  -157,  -157,  -157,  -157,  -157,  -157,    23,   195,   207,
   208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
   218,   219,   220,   221,   222,   223,   224,   225,   226,     0,
   196,   197,    56,    23,    57,    58,    59,    60,    61,    62,
    63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
    73,    74,     0,     0,     0,     0,     0,     0,     0,    23,
     0,     0,     0,     0,     0,     0,     0,     0,   198,   199,
   200,   201,   202,   203,   204,   205,  -157,  -157,     0,     0,
     0,     0,     0,     0,     0,    31,    59,    60,    61,    62,
    63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
    73,    74,    60,    61,    62,    63,    64,    65,    66,    67,
    68,    69,    70,    71,    72,    73,    74
};

static const short yycheck[] = {     1,
   163,     3,     4,     5,     6,    26,   480,    18,    27,    27,
   156,   413,   414,    27,   160,   489,   416,   417,     1,    48,
    63,    23,   156,    50,    25,   159,   160,   156,   156,    31,
    20,    21,    22,   156,    36,    37,    38,    39,    40,    41,
    42,    43,    44,    45,    46,    47,    48,   396,   156,    91,
   156,    27,   156,    54,   156,   156,   156,    59,    60,    61,
    62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
    72,    73,    74,     3,   156,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    95,    96,    97,    16,    17,    18,    19,
    20,    21,    22,   452,    18,    19,    20,    21,    22,     3,
   156,     5,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    58,
   159,   160,   156,   156,   160,    26,   178,   156,   156,   160,
   159,   160,   156,   145,   156,   156,    27,    27,   150,   160,
     0,   153,    44,   157,   196,   197,   198,   199,   200,     1,
    26,   203,   204,   205,    26,    26,    26,   155,    26,   211,
   212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
   156,   158,    49,   159,   160,    27,   158,   229,   351,     3,
    29,     5,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    51,
    52,    53,    54,    55,    56,    57,    58,    29,    29,    29,
     1,    63,    64,    65,    66,    67,    68,    26,    26,    26,
   160,    26,   395,   157,   157,    26,    26,   239,    26,    45,
   156,   283,   284,   285,    26,   158,   288,    26,    26,   291,
   292,   293,   294,   295,   296,   297,   298,   299,   300,   301,
   302,   303,   304,   305,   306,   307,   160,    26,    26,   432,
    51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
    61,    62,    26,    26,    26,   158,   128,   129,    48,    26,
   160,    63,    64,   157,   157,   337,   338,   339,   340,   341,
   342,   343,   344,   345,   346,   347,   348,   156,     1,   157,
     0,     0,   494,    -1,   156,    -1,    -1,   359,   360,   361,
   362,   363,    -1,    -1,   366,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    27,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,   160,   128,   129,    -1,
    -1,    -1,    -1,   125,    -1,    -1,    -1,    -1,    51,    52,
    53,    54,    55,    56,    57,    58,    -1,    60,    -1,    -1,
    -1,   143,   144,    -1,    -1,    -1,    69,    70,   150,   151,
   152,   153,   154,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,   399,   400,   401,
   402,   403,   404,   405,   406,   407,   408,   409,   410,   451,
   412,   413,   414,   415,   416,   417,   399,   400,   401,   402,
   403,   404,   405,   406,   407,   408,   409,   410,    -1,    -1,
    -1,    -1,   415,   416,   417,   128,   129,    -1,    -1,    -1,
    -1,    -1,    -1,   485,    -1,    -1,    -1,    -1,    -1,    -1,
   492,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
   502,    -1,     3,   156,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,     3,    -1,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,     3,    -1,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,     3,    -1,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,     3,    -1,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,     3,    -1,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,     3,    -1,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,     3,   157,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,     3,   157,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,     3,   157,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,     3,   157,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,     3,   157,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,     3,   157,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,     3,   157,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    -1,    -1,    -1,    -1,    -1,
    -1,    51,    52,    53,    54,    55,    56,    57,    58,   157,
     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   157,
    -1,    -1,    -1,    -1,    -1,    26,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    26,    -1,    -1,    -1,   157,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    51,    52,    53,    54,    55,    56,    57,    58,    -1,   157,
    51,    52,    53,    54,    55,    56,    57,    58,   128,   129,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   157,
    71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
    81,    82,    83,    84,    85,    86,    87,    -1,    -1,   157,
    -1,   102,   103,   104,   105,   106,   107,   108,   109,   110,
   111,   112,   113,   114,   115,   116,   117,   118,   119,   157,
     1,    -1,    -1,    -1,    -1,    -1,    -1,   128,   129,    -1,
    -1,    -1,    -1,    -1,     1,    -1,    -1,   128,   129,    -1,
    -1,    -1,    -1,    -1,    -1,    26,    -1,    -1,    -1,    -1,
   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    26,
   151,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    51,    52,    53,    54,    55,    56,    57,    58,    -1,    -1,
    -1,    -1,    -1,    -1,    51,    52,    53,    54,    55,    56,
    57,    58,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    90,
    91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
   101,    88,    89,     3,     4,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    -1,    -1,    -1,    -1,   128,   129,   317,
   318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
    -1,   128,   129,   331,   332,   333,   334,   335,   336,    -1,
   151,    -1,    -1,    18,    19,    -1,    -1,    -1,    -1,    24,
    25,    -1,    27,    28,   151,    30,    31,    32,    33,    34,
    35,    36,    37,    38,    39,    40,    41,    42,    43,    18,
    19,    -1,    -1,    -1,    -1,    24,    25,    -1,    27,    28,
    -1,    30,    31,    32,    33,    34,    35,    36,    37,    38,
    39,    40,    41,    42,    43,    18,    19,    46,    47,    -1,
    -1,    24,    25,    -1,    27,    28,    -1,    30,    31,    32,
    33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
    43,    18,    19,    46,    -1,    -1,    -1,    24,    25,    -1,
    27,    28,    -1,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    18,    19,     1,
    -1,    -1,    -1,    24,    25,    -1,    27,    28,    -1,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    41,    42,    43,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   156,    -1,    -1,    -1,   160,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    51,
    52,    53,    54,    55,    56,    57,    58,   156,    60,   130,
   131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
   141,   142,   143,   144,   145,   146,   147,   148,   149,    -1,
    82,    83,     3,   156,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   156,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   120,   121,
   122,   123,   124,   125,   126,   127,   128,   129,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   156,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 184 "/usr/lib/bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 3:
#line 180 "parser.y"
{
		last_x = 0;
		last_y = 0;
		last_z = 0;
		last_material = NULL;
		last_constraint = NULL;
	    ;
    break;}
case 8:
#line 206 "parser.y"
{
		Deallocate (problem.title);
		problem.title = yyvsp[0].s;
	    ;
    break;}
case 9:
#line 212 "parser.y"
{
		problem.num_nodes = yyvsp[0].i;
	    ;
    break;}
case 10:
#line 217 "parser.y"
{
		problem.num_elements = yyvsp[0].i;
	    ;
    break;}
case 11:
#line 222 "parser.y"
{
		problem.mode = yyvsp[0].i;
	    ;
    break;}
case 29:
#line 272 "parser.y"
{
		if (yyvsp[0].i < 1 || yyvsp[0].i > problem.num_nodes) {
		    error ("node number %u is illegal", yyvsp[0].i);
		    node = &dummy_node;
		    break;
		}

		node = CreateNode (yyvsp[0].i);
		found = TreeInsert (problem.node_tree, node);

		if (found != (Item) node) {
		    error ("node number %u is repeated", yyvsp[0].i);
		    DestroyNode (node);
		    node = &dummy_node;
		    break;
		}

		node -> x = last_x;
		node -> y = last_y;
		node -> z = last_z;
		node -> constraint = last_constraint ?
			(Constraint) strdup (last_constraint) : NULL;
	    ;
    break;}
case 31:
#line 301 "parser.y"
{yyval.i = yyvsp[-1].d;;
    break;}
case 34:
#line 313 "parser.y"
{
		node -> x = last_x = yyvsp[0].d;
	    ;
    break;}
case 35:
#line 318 "parser.y"
{
		node -> y = last_y = yyvsp[0].d;
	    ;
    break;}
case 36:
#line 323 "parser.y"
{
		node -> z = last_z = yyvsp[0].d;
	    ;
    break;}
case 37:
#line 328 "parser.y"
{
                node -> m = yyvsp[0].d;
            ;
    break;}
case 38:
#line 333 "parser.y"
{
		Deallocate (node -> force);
		node -> force = (Force) yyvsp[0].s;
	    ;
    break;}
case 39:
#line 339 "parser.y"
{
		node -> constraint = (Constraint) (last_constraint = yyvsp[0].s);
	    ;
    break;}
case 42:
#line 356 "parser.y"
{
		definition = defnlookup (yyvsp[0].s);
		Deallocate (yyvsp[0].s);
		if (!definition)
		    return 1;
	    ;
    break;}
case 46:
#line 378 "parser.y"
{
		if (yyvsp[0].i < 1 || yyvsp[0].i > problem.num_elements) {
		    error ("element number %u is illegal", yyvsp[0].i);
		    element = &dummy_element;
		    break;
		}

		element = CreateElement (yyvsp[0].i, definition);
		found = TreeInsert (problem.element_tree, element);

		if (found != (Item) element) {
		    error ("element number %u is repeated", yyvsp[0].i);
		    DestroyElement (element);
		    element = &dummy_element;
		    break;
		}

		element -> material = last_material ?
			(Material) strdup (last_material) : NULL;
	    ;
    break;}
case 48:
#line 404 "parser.y"
{yyval.i = yyvsp[-1].d;;
    break;}
case 51:
#line 416 "parser.y"
{
		unsigned i;
		unsigned size;
		unsigned number;


		if (element == &dummy_element)
		    break;

		size = int_ptr - int_array;

		if (size != element -> definition -> numnodes) {
		    number = element -> number;
		    error ("incorrect number of nodes for element %u", number);
		    break;
		}

		for (i = 1; i <= size; i ++)
		    element -> node [i] = (Node) int_array [i - 1];
	    ;
    break;}
case 52:
#line 438 "parser.y"
{
		element -> material = (Material) (last_material = yyvsp[0].s);
	    ;
    break;}
case 55:
#line 450 "parser.y"
{
		*int_ptr ++ = yyvsp[0].i;
	    ;
    break;}
case 56:
#line 455 "parser.y"
{
		*int_ptr ++ = yyvsp[0].i;
	    ;
    break;}
case 57:
#line 460 "parser.y"
{
		int_ptr = int_array;
		*int_ptr ++ = yyvsp[0].i;
	    ;
    break;}
case 58:
#line 469 "parser.y"
{
		if (yyvsp[0].i > problem.num_nodes)
		    error ("node number %u is illegal", yyvsp[0].i);
	    ;
    break;}
case 59:
#line 478 "parser.y"
{
		if (element -> numdistributed == 3) {
		    error ("element %u has too many loads", element -> number);
		    break;
		}

		element -> numdistributed ++;
		Deallocate (element -> distributed [element -> numdistributed]);
		element -> distributed [element -> numdistributed] =
		  (Distributed) yyvsp[0].s;
	    ;
    break;}
case 60:
#line 491 "parser.y"
{
		if (element -> numdistributed == 3) {
		    error ("element %u has too many loads", element -> number);
		    break;
		}

		element -> numdistributed ++;
		Deallocate (element -> distributed [element -> numdistributed]);
		element -> distributed [element -> numdistributed] =
		  (Distributed) yyvsp[0].s;
	    ;
    break;}
case 61:
#line 504 "parser.y"
{
		element -> numdistributed = 1;
		Deallocate (element -> distributed [element -> numdistributed]);
		element -> distributed [element -> numdistributed] =
		  (Distributed) yyvsp[0].s;
	    ;
    break;}
case 66:
#line 533 "parser.y"
{
		material = CreateMaterial (yyvsp[0].s);
		found = TreeInsert (problem.material_tree, material);

		if (found != (Item) material) {
		    error ("material %s is previously defined", yyvsp[0].s);
		    DestroyMaterial (material);
		    material = &dummy_material;
		}
	    ;
    break;}
case 69:
#line 553 "parser.y"
{
		Deallocate (material -> color);
                material -> color = yyvsp[0].s;
	    ;
    break;}
case 70:
#line 559 "parser.y"
{
		material -> E = yyvsp[0].d;
	    ;
    break;}
case 71:
#line 564 "parser.y"
{
		material -> Ix = yyvsp[0].d;
	    ;
    break;}
case 72:
#line 569 "parser.y"
{
		material -> Iy = yyvsp[0].d;
	    ;
    break;}
case 73:
#line 574 "parser.y"
{
		material -> Iz = yyvsp[0].d;
	    ;
    break;}
case 74:
#line 579 "parser.y"
{
		material -> A = yyvsp[0].d;
	    ;
    break;}
case 75:
#line 584 "parser.y"
{
		material -> J = yyvsp[0].d;
	    ;
    break;}
case 76:
#line 589 "parser.y"
{
		material -> G = yyvsp[0].d;
	    ;
    break;}
case 77:
#line 594 "parser.y"
{
		material -> t = yyvsp[0].d;
	    ;
    break;}
case 78:
#line 599 "parser.y"
{
		material -> rho = yyvsp[0].d;
	    ;
    break;}
case 79:
#line 604 "parser.y"
{
		material -> nu = yyvsp[0].d;
	    ;
    break;}
case 80:
#line 609 "parser.y"
{
		material -> kappa = yyvsp[0].d;
	    ;
    break;}
case 81:
#line 614 "parser.y"
{
		material -> Rk = yyvsp[0].d;
	    ;
    break;}
case 82:
#line 619 "parser.y"
{
		material -> Rm = yyvsp[0].d;
	    ;
    break;}
case 83:
#line 624 "parser.y"
{
                material -> Kx = yyvsp[0].d;
            ;
    break;}
case 84:
#line 629 "parser.y"
{
                material -> Ky = yyvsp[0].d;
            ;
    break;}
case 85:
#line 634 "parser.y"
{
                material -> Kz = yyvsp[0].d;
            ;
    break;}
case 86:
#line 639 "parser.y"
{
                material -> c = yyvsp[0].d;
            ;
    break;}
case 92:
#line 667 "parser.y"
{
		load = CreateDistributed (yyvsp[0].s, 0);
		found = TreeInsert (problem.distributed_tree, load);

		if (found != (Item) load) {
		    error ("load %s is previously defined", yyvsp[0].s);
		    DestroyDistributed (load);
		    load = &dummy_load;
		}
	    ;
    break;}
case 95:
#line 688 "parser.y"
{
		Deallocate (load -> color);
                load -> color = yyvsp[0].s;
	    ;
    break;}
case 96:
#line 694 "parser.y"
{
		load -> direction = yyvsp[0].i;
	    ;
    break;}
case 97:
#line 699 "parser.y"
{
		unsigned i;
		unsigned size;


		if (load == &dummy_load)
		    break;

		size = pair_ptr - pair_array;

		if (!(load -> value = Allocate (Pair, size)))
		    Fatal ("unable to allocate memory for pairs");

		UnitOffset (load -> value);
		load -> nvalues = size;

		for (i = 1; i <= size; i ++)
		    load -> value [i] = pair_array [i - 1];
	    ;
    break;}
case 99:
#line 725 "parser.y"
{
		*pair_ptr ++ = yyvsp[0].p;
	    ;
    break;}
case 100:
#line 730 "parser.y"
{
		*pair_ptr ++ = yyvsp[0].p;
	    ;
    break;}
case 101:
#line 735 "parser.y"
{
		pair_ptr = pair_array;
		*pair_ptr ++ = yyvsp[0].p;
	    ;
    break;}
case 102:
#line 744 "parser.y"
{
		if (yyvsp[-3].i < 1 || yyvsp[-3].i > problem.num_nodes)
		    error ("node number %u is illegal", yyvsp[-3].i);

		yyval.p.node = yyvsp[-3].i;
		yyval.p.magnitude = yyvsp[-1].d;
	    ;
    break;}
case 103:
#line 753 "parser.y"
{
		if (yyvsp[-2].i < 1 || yyvsp[-2].i > problem.num_nodes)
		    error ("node number %u is illegal", yyvsp[-2].i);

		yyval.p.node = yyvsp[-2].i;
		yyval.p.magnitude = yyvsp[-1].d;
	    ;
    break;}
case 108:
#line 783 "parser.y"
{
		force = CreateForce (yyvsp[0].s);
		found = TreeInsert (problem.force_tree, force);

		if (found != (Item) force) {
		    error ("force %s is previously defined", yyvsp[0].s);
		    DestroyForce (force);
		    force = &dummy_force;
		}
	    ;
    break;}
case 111:
#line 804 "parser.y"
{
		Deallocate (force -> color);
                force -> color = yyvsp[0].s;
	    ;
    break;}
case 112:
#line 810 "parser.y"
{
		AssignForce (force, Fx, InCore, copy_input (0));
	    ;
    break;}
case 113:
#line 815 "parser.y"
{
		AssignForce (force, Fy, InCore, copy_input (0));
	    ;
    break;}
case 114:
#line 820 "parser.y"
{
		AssignForce (force, Fz, InCore, copy_input (0));
	    ;
    break;}
case 115:
#line 825 "parser.y"
{
		AssignForce (force, Mx, InCore, copy_input (0));
	    ;
    break;}
case 116:
#line 830 "parser.y"
{
		AssignForce (force, My, InCore, copy_input (0));
	    ;
    break;}
case 117:
#line 835 "parser.y"
{
		AssignForce (force, Mz, InCore, copy_input (0));
	    ;
    break;}
case 118:
#line 840 "parser.y"
{
		AssignSpectrum (force, Fx, InCore, copy_input (0));
	    ;
    break;}
case 119:
#line 845 "parser.y"
{
		AssignSpectrum (force, Fy, InCore, copy_input (0));
	    ;
    break;}
case 120:
#line 850 "parser.y"
{
		AssignSpectrum (force, Fz, InCore, copy_input (0));
	    ;
    break;}
case 121:
#line 855 "parser.y"
{
		AssignSpectrum (force, Mx, InCore, copy_input (0));
	    ;
    break;}
case 122:
#line 860 "parser.y"
{
		AssignSpectrum (force, My, InCore, copy_input (0));
	    ;
    break;}
case 123:
#line 865 "parser.y"
{
		AssignSpectrum (force, Mz, InCore, copy_input (0));
	    ;
    break;}
case 129:
#line 893 "parser.y"
{
		constraint = CreateConstraint (yyvsp[0].s);
		found = TreeInsert (problem.constraint_tree, constraint);

		if (found != (Item) constraint) {
		    error ("constraint %s is previously defined", yyvsp[0].s);
		    DestroyConstraint (constraint);
		    constraint = &dummy_constraint;
		}
	    ;
    break;}
case 132:
#line 914 "parser.y"
{
		Deallocate (constraint -> color);
                constraint -> color = yyvsp[0].s;
	    ;
    break;}
case 133:
#line 920 "parser.y"
{
                if (yyvsp[0].c == VariableExpression)
                   AssignConstraint (constraint, Tx, InCore, copy_input(0), 1);
                else  {
                   AssignConstraint (constraint, Tx, NULL, NULL, yyvsp[0].c);
		   copy_input (0);
		}
	    ;
    break;}
case 134:
#line 930 "parser.y"
{
                if (yyvsp[0].c == VariableExpression)
                   AssignConstraint (constraint, Ty, InCore, copy_input(0), 1);
                else {
                   AssignConstraint (constraint, Ty, NULL, NULL, yyvsp[0].c);
		   copy_input (0);
		}
	    ;
    break;}
case 135:
#line 940 "parser.y"
{
                if (yyvsp[0].c == VariableExpression)
                   AssignConstraint (constraint, Tz, InCore, copy_input(0), 1);
                else {
                   AssignConstraint (constraint, Tz, NULL, NULL, yyvsp[0].c);
		   copy_input (0);
		}
	    ;
    break;}
case 136:
#line 950 "parser.y"
{
                if (yyvsp[0].c == VariableExpression)
                   AssignConstraint (constraint, Rx, InCore, copy_input(0), 1);
                else {
                   AssignConstraint (constraint, Rx, NULL, NULL, yyvsp[0].c);
		   copy_input (0);
		}
	    ;
    break;}
case 137:
#line 960 "parser.y"
{
                if (yyvsp[0].c == VariableExpression)
                   AssignConstraint (constraint, Ry, InCore, copy_input(0), 1);
                else {
                   AssignConstraint (constraint, Ry, NULL, NULL, yyvsp[0].c);
		   copy_input (0);
		}
	    ;
    break;}
case 138:
#line 970 "parser.y"
{
                if (yyvsp[0].c == VariableExpression)
                   AssignConstraint (constraint, Rz, InCore, copy_input(0), 1);
                else {
                   AssignConstraint (constraint, Rz, NULL, NULL, yyvsp[0].c);
		   copy_input (0);
		}
	    ;
    break;}
case 139:
#line 980 "parser.y"
{
                constraint -> ix [Tx] = yyvsp[0].d;
            ;
    break;}
case 140:
#line 985 "parser.y"
{
                constraint -> ix [Ty] = yyvsp[0].d;
            ;
    break;}
case 141:
#line 990 "parser.y"
{
                constraint -> ix [Tz] = yyvsp[0].d;
            ;
    break;}
case 142:
#line 995 "parser.y"
{
                constraint -> ix [Rx] = yyvsp[0].d;
            ;
    break;}
case 143:
#line 1000 "parser.y"
{
                constraint -> ix [Ry] = yyvsp[0].d;
            ;
    break;}
case 144:
#line 1005 "parser.y"
{
                constraint -> ix [Rz] = yyvsp[0].d;
            ;
    break;}
case 145:
#line 1010 "parser.y"
{
		constraint -> vx [Tx] = yyvsp[0].d;
	    ;
    break;}
case 146:
#line 1015 "parser.y"
{
		constraint -> vx [Ty] = yyvsp[0].d;
	    ;
    break;}
case 147:
#line 1020 "parser.y"
{
		constraint -> vx [Tz] = yyvsp[0].d;
	    ;
    break;}
case 148:
#line 1025 "parser.y"
{
		constraint -> ax [Tx] = yyvsp[0].d;
	    ;
    break;}
case 149:
#line 1030 "parser.y"
{
		constraint -> ax [Ty] = yyvsp[0].d;
	    ;
    break;}
case 150:
#line 1035 "parser.y"
{
		constraint -> ax [Tz] = yyvsp[0].d;
	    ;
    break;}
case 152:
#line 1045 "parser.y"
{
		yyval.c = VariableExpression;
	    ;
    break;}
case 153:
#line 1050 "parser.y"
{
		yyval.c = yyvsp[0].i;
	    ;
    break;}
case 154:
#line 1058 "parser.y"
{
		yyval.c = VariableExpression;
	    ;
    break;}
case 155:
#line 1063 "parser.y"
{
		yyval.c = yyvsp[0].i;
	    ;
    break;}
case 156:
#line 1068 "parser.y"
{
		yyval.c = yyvsp[0].i;
	    ;
    break;}
case 160:
#line 1089 "parser.y"
{
		analysis.alpha = yyvsp[0].d;
	    ;
    break;}
case 161:
#line 1094 "parser.y"
{
		analysis.beta = yyvsp[0].d;
	    ;
    break;}
case 162:
#line 1099 "parser.y"
{
		analysis.gamma = yyvsp[0].d;
	    ;
    break;}
case 163:
#line 1104 "parser.y"
{
                analysis.Rk = yyvsp[0].d;
            ;
    break;}
case 164:
#line 1109 "parser.y"
{
                analysis.Rm = yyvsp[0].d;
            ;
    break;}
case 165:
#line 1114 "parser.y"
{
		analysis.start = yyvsp[0].d;
	    ;
    break;}
case 166:
#line 1119 "parser.y"
{
		analysis.step = yyvsp[0].d;
	    ;
    break;}
case 167:
#line 1124 "parser.y"
{
		analysis.stop = yyvsp[0].d;
	    ;
    break;}
case 168:
#line 1129 "parser.y"
{
		unsigned i;


		analysis.numnodes = int_ptr - int_array;

		if (!(analysis.nodes = Allocate (unsigned, analysis.numnodes)))
		    Fatal ("unable to allocate memory for analysis nodes");

		UnitOffset (analysis.nodes);
		for (i = 1; i <= analysis.numnodes; i ++)
		    analysis.nodes [i] = int_array [i - 1];
	    ;
    break;}
case 169:
#line 1144 "parser.y"
{
		int i;


		analysis.numdofs = 0;
		for (i = 1; i <= 6; i ++)
		    if (analysis.dofs [i])
			analysis.dofs [++ analysis.numdofs] = i;
	    ;
    break;}
case 170:
#line 1155 "parser.y"
{
		analysis.mass_mode = yyvsp[0].i;
	    ;
    break;}
case 172:
#line 1165 "parser.y"
{
		*int_ptr ++ = yyvsp[0].i;
	    ;
    break;}
case 173:
#line 1170 "parser.y"
{
		*int_ptr ++ = yyvsp[0].i;
	    ;
    break;}
case 174:
#line 1175 "parser.y"
{
		int_ptr = int_array;
	    ;
    break;}
case 175:
#line 1183 "parser.y"
{
		analysis.dofs [yyvsp[0].i] = 1;
	    ;
    break;}
case 176:
#line 1188 "parser.y"
{
		analysis.dofs [yyvsp[0].i] = 1;
	    ;
    break;}
case 177:
#line 1193 "parser.y"
{
		int i;


		for (i = 1; i <= 6; i ++)
		     analysis.dofs [i] = 0;
	    ;
    break;}
case 181:
#line 1218 "parser.y"
{
		appearance.node_numbers = yyvsp[0].i;
	    ;
    break;}
case 182:
#line 1223 "parser.y"
{
		appearance.element_numbers = yyvsp[0].i;
	    ;
    break;}
case 183:
#line 1228 "parser.y"
{
		appearance.snap = yyvsp[0].i;
	    ;
    break;}
case 184:
#line 1233 "parser.y"
{
		appearance.grid = yyvsp[0].i;
	    ;
    break;}
case 185:
#line 1238 "parser.y"
{
		appearance.snap_size = yyvsp[0].d;
	    ;
    break;}
case 186:
#line 1243 "parser.y"
{
		appearance.grid_size = yyvsp[0].d;
	    ;
    break;}
case 187:
#line 1248 "parser.y"
{
		appearance.x_min = yyvsp[0].d;
	    ;
    break;}
case 188:
#line 1253 "parser.y"
{
		appearance.x_max = yyvsp[0].d;
	    ;
    break;}
case 189:
#line 1258 "parser.y"
{
		appearance.y_min = yyvsp[0].d;
	    ;
    break;}
case 190:
#line 1263 "parser.y"
{
		appearance.y_max = yyvsp[0].d;
	    ;
    break;}
case 191:
#line 1268 "parser.y"
{
		appearance.x_pos = yyvsp[0].d;
	    ;
    break;}
case 192:
#line 1273 "parser.y"
{
		appearance.y_pos = yyvsp[0].d;
	    ;
    break;}
case 193:
#line 1278 "parser.y"
{
		appearance.width = yyvsp[0].d;
	    ;
    break;}
case 194:
#line 1283 "parser.y"
{
		appearance.height = yyvsp[0].d;
	    ;
    break;}
case 195:
#line 1288 "parser.y"
{
		appearance.scale = yyvsp[0].d;
	    ;
    break;}
case 196:
#line 1293 "parser.y"
{
		Deallocate (appearance.node_color);
		appearance.node_color = yyvsp[0].s;
	    ;
    break;}
case 197:
#line 1299 "parser.y"
{
		Deallocate (appearance.element_color);
		appearance.element_color = yyvsp[0].s;
	    ;
    break;}
case 198:
#line 1305 "parser.y"
{
		Deallocate (appearance.label_font);
		appearance.label_font = yyvsp[0].s;
	    ;
    break;}
case 199:
#line 1311 "parser.y"
{
		Deallocate (appearance.tool_color);
		appearance.tool_color = yyvsp[0].s;
	    ;
    break;}
case 200:
#line 1317 "parser.y"
{
		Deallocate (appearance.tool_font);
		appearance.tool_font = yyvsp[0].s;
	    ;
    break;}
case 202:
#line 1333 "parser.y"
{
		figure_size = 0;
	    ;
    break;}
case 206:
#line 1352 "parser.y"
{
		if (appearance.num_figures == figure_size) {
		    figure_size = figure_size ? figure_size <<= 1 : 4;
		    if (!Reallocate (appearance.figures, FigInfo, figure_size))
			Fatal ("unable to allocate figure list");
		}

		figure = &appearance.figures [appearance.num_figures ++];
		figure -> type = yyvsp[0].i;
		figure -> x = 0;
		figure -> y = 0;
		figure -> width = 0;
		figure -> height = 0;
		figure -> start = 0;
		figure -> length = 0;
		figure -> num_points = 0;
		figure -> points = NULL;
		figure -> font = NULL;
		figure -> text = NULL;
		figure -> color = NULL;
	    ;
    break;}
case 209:
#line 1384 "parser.y"
{
		figure -> x = yyvsp[0].d;
	    ;
    break;}
case 210:
#line 1389 "parser.y"
{
		figure -> y = yyvsp[0].d;
	    ;
    break;}
case 211:
#line 1394 "parser.y"
{
		figure -> width = yyvsp[0].d;
	    ;
    break;}
case 212:
#line 1399 "parser.y"
{
		figure -> height = yyvsp[0].d;
	    ;
    break;}
case 213:
#line 1404 "parser.y"
{
		figure -> start = yyvsp[0].d;
	    ;
    break;}
case 214:
#line 1409 "parser.y"
{
		figure -> length = yyvsp[0].d;
	    ;
    break;}
case 215:
#line 1414 "parser.y"
{
		Deallocate (figure -> text);
		figure -> text = yyvsp[0].s;
	    ;
    break;}
case 216:
#line 1420 "parser.y"
{
		Deallocate (figure -> color);
		figure -> color = yyvsp[0].s;
	    ;
    break;}
case 217:
#line 1426 "parser.y"
{
		Deallocate (figure -> font);
		figure -> font = yyvsp[0].s;
	    ;
    break;}
case 219:
#line 1437 "parser.y"
{
		if (fig_point_size == figure -> num_points) {
		    fig_point_size <<= 1;
		    Reallocate (figure -> points, FigInfoPair, fig_point_size);
		    if (figure -> points == NULL)
			Fatal ("unable to allocate figure points");
		}

		figure -> points [figure -> num_points].x = figure_x;
		figure -> points [figure -> num_points ++].y = figure_y;
	    ;
    break;}
case 220:
#line 1450 "parser.y"
{
		if (fig_point_size == figure -> num_points) {
		    fig_point_size <<= 1;
		    Reallocate (figure -> points, FigInfoPair, fig_point_size);
		    if (figure -> points == NULL)
			Fatal ("unable to allocate figure points");
		}

		figure -> points [figure -> num_points].x = figure_x;
		figure -> points [figure -> num_points ++].y = figure_y;
	    ;
    break;}
case 221:
#line 1463 "parser.y"
{
		figure -> points = Allocate (FigInfoPair, 2);
		if (figure -> points == NULL)
		    Fatal ("unable to allocate figure points");

		fig_point_size = 2;
		figure -> num_points = 0;
	    ;
    break;}
case 222:
#line 1476 "parser.y"
{
		figure_x = yyvsp[-3].d;
		figure_y = yyvsp[-1].d;
	    ;
    break;}
case 223:
#line 1487 "parser.y"
{
		EmitCode (HaltOp);
		SetIP (0);
	    ;
    break;}
case 224:
#line 1493 "parser.y"
{
		if (table_error)
		    EmitCode (PushOp, 0.0);
		else
		    EmitCode (TableOp, table, table_count);

		EmitCode (HaltOp);
		table_count = 0;
		table_error = 0;
		last_time = 0;
		SetIP (0);
	    ;
    break;}
case 225:
#line 1507 "parser.y"
{
		if (table_error)
		    EmitCode (PushOp, 0.0);
		else
		    EmitCode (CycleOp, table, table_count);

		EmitCode (HaltOp);
		table_count = 0;
		table_error = 0;
		last_time = 0;
		SetIP (0);
	    ;
    break;}
case 229:
#line 1531 "parser.y"
{
		if (yyvsp[-3].d < last_time) {
		    error ("point not in nondecreasing order");
		    table_error = 1;
		    break;
		}

		if (table_count == table_size) {
		    table_size = table_size ? table_size << 1 : 8;
		    if (!Reallocate (table, double, table_size))
			Fatal ("unable to expand table");
		}

		table [table_count ++] = last_time = yyvsp[-3].d;
		table [table_count ++] = yyvsp[-1].d;
	    ;
    break;}
case 230:
#line 1552 "parser.y"
{
		copy_input (1);
	    ;
    break;}
case 231:
#line 1560 "parser.y"
{
		EmitCode (HaltOp);
		SetIP (0);
		yyval.d = EvalCode (InCore, 0.0);
	    ;
    break;}
case 232:
#line 1570 "parser.y"
{
		int ip = GetIP ( );
		SetIP (ip - yyvsp[0].i - 2);
		EmitCode (JmpOp, yyvsp[0].i);
		SetIP (GetIP ( ) - yyvsp[-3].i - 4);
		EmitCode (JzOp, yyvsp[-3].i + 2);
		SetIP (ip);
		yyval.i = yyvsp[-6].i + yyvsp[-4].i + yyvsp[-3].i + yyvsp[-1].i + yyvsp[0].i;
	    ;
    break;}
case 233:
#line 1581 "parser.y"
{
		int ip = GetIP ( );
		SetIP (ip - yyvsp[0].i - 3);
		EmitCode (JnzOp, yyvsp[0].i + 1);
		SetIP (ip);
		EmitCode (TestOp);
		yyval.i = yyvsp[-3].i + yyvsp[-1].i + yyvsp[0].i + 1;
	    ;
    break;}
case 234:
#line 1591 "parser.y"
{
		int ip = GetIP ( );
		SetIP (ip - yyvsp[0].i - 3);
		EmitCode (JzOp, yyvsp[0].i + 1);
		SetIP (ip);
		EmitCode (TestOp);
		yyval.i = yyvsp[-3].i + yyvsp[-1].i + yyvsp[0].i + 1;
	    ;
    break;}
case 235:
#line 1601 "parser.y"
{
		EmitCode (OrOp);
		yyval.i = yyvsp[-2].i + 1 + yyvsp[0].i;
	    ;
    break;}
case 236:
#line 1607 "parser.y"
{
		EmitCode (XorOp);
		yyval.i = yyvsp[-2].i + 1 + yyvsp[0].i;
	    ;
    break;}
case 237:
#line 1613 "parser.y"
{
		EmitCode (AndOp);
		yyval.i = yyvsp[-2].i + 1 + yyvsp[0].i;
	    ;
    break;}
case 238:
#line 1619 "parser.y"
{
		EmitCode (EqOp);
		yyval.i = yyvsp[-2].i + 1 + yyvsp[0].i;
	    ;
    break;}
case 239:
#line 1625 "parser.y"
{
		EmitCode (NeqOp);
		yyval.i = yyvsp[-2].i + 1 + yyvsp[0].i;
	    ;
    break;}
case 240:
#line 1631 "parser.y"
{
		EmitCode (LtOp);
		yyval.i = yyvsp[-2].i + 1 + yyvsp[0].i;
	    ;
    break;}
case 241:
#line 1637 "parser.y"
{
		EmitCode (GtOp);
		yyval.i = yyvsp[-2].i + 1 + yyvsp[0].i;
	    ;
    break;}
case 242:
#line 1643 "parser.y"
{
		EmitCode (LteqOp);
		yyval.i = yyvsp[-2].i + 1 + yyvsp[0].i;
	    ;
    break;}
case 243:
#line 1649 "parser.y"
{
		EmitCode (GteqOp);
		yyval.i = yyvsp[-2].i + 1 + yyvsp[0].i;
	    ;
    break;}
case 244:
#line 1655 "parser.y"
{
		EmitCode (LsftOp);
		yyval.i = yyvsp[-2].i + 1 + yyvsp[0].i;
	    ;
    break;}
case 245:
#line 1661 "parser.y"
{
		EmitCode (RsftOp);
		yyval.i = yyvsp[-2].i + 1 + yyvsp[0].i;
	    ;
    break;}
case 246:
#line 1667 "parser.y"
{
		EmitCode (AddOp);
		yyval.i = yyvsp[-2].i + 1 + yyvsp[0].i;
	    ;
    break;}
case 247:
#line 1673 "parser.y"
{
		EmitCode (SubOp);
		yyval.i = yyvsp[-2].i + 1 + yyvsp[0].i;
	    ;
    break;}
case 248:
#line 1679 "parser.y"
{
		EmitCode (MulOp);
		yyval.i = yyvsp[-2].i + 1 + yyvsp[0].i;
	    ;
    break;}
case 249:
#line 1685 "parser.y"
{
		EmitCode (DivOp);
		yyval.i = yyvsp[-2].i + 1 + yyvsp[0].i;
	    ;
    break;}
case 250:
#line 1691 "parser.y"
{
		EmitCode (ModOp);
		yyval.i = yyvsp[-2].i + 1 + yyvsp[0].i;
	    ;
    break;}
case 251:
#line 1697 "parser.y"
{
		yyval.i = yyvsp[0].i;
	    ;
    break;}
case 252:
#line 1702 "parser.y"
{
		EmitCode (NegOp);
		yyval.i = 1 + yyvsp[0].i;
	    ;
    break;}
case 253:
#line 1708 "parser.y"
{
		EmitCode (NotOp);
		yyval.i = 1 + yyvsp[0].i;
	    ;
    break;}
case 254:
#line 1714 "parser.y"
{
		EmitCode (InvOp);
		yyval.i = 1 + yyvsp[0].i;
	    ;
    break;}
case 255:
#line 1720 "parser.y"
{
		yyval.i = yyvsp[-1].i;
	    ;
    break;}
case 256:
#line 1725 "parser.y"
{
		EmitCode (PushOp, (double) yyvsp[0].i);
		yyval.i = 2;
	    ;
    break;}
case 257:
#line 1731 "parser.y"
{
		EmitCode (PushOp, yyvsp[0].d);
		yyval.i = 2;
	    ;
    break;}
case 258:
#line 1737 "parser.y"
{
		EmitCode (TimeOp);
		yyval.i = 1;
	    ;
    break;}
case 260:
#line 1748 "parser.y"
{
		EmitCode (SinOp);
		yyval.i = yyvsp[-1].i + 1;
	    ;
    break;}
case 261:
#line 1754 "parser.y"
{
		EmitCode (CosOp);
		yyval.i = yyvsp[-1].i + 1;
	    ;
    break;}
case 262:
#line 1760 "parser.y"
{
		EmitCode (TanOp);
		yyval.i = yyvsp[-1].i + 1;
	    ;
    break;}
case 263:
#line 1766 "parser.y"
{
		EmitCode (PowOp);
		yyval.i = yyvsp[-3].i + yyvsp[-1].i + 1;
	    ;
    break;}
case 264:
#line 1772 "parser.y"
{
		EmitCode (ExpOp);
		yyval.i = yyvsp[-1].i + 1;
	    ;
    break;}
case 265:
#line 1778 "parser.y"
{
		EmitCode (LnOp);
		yyval.i = yyvsp[-1].i + 1;
	    ;
    break;}
case 266:
#line 1784 "parser.y"
{
		EmitCode (LogOp);
		yyval.i = yyvsp[-1].i + 1;
	    ;
    break;}
case 267:
#line 1790 "parser.y"
{
		EmitCode (SqrtOp);
		yyval.i = yyvsp[-1].i + 1;
	    ;
    break;}
case 268:
#line 1796 "parser.y"
{
		EmitCode (HypotOp);
		yyval.i = yyvsp[-3].i + yyvsp[-1].i + 1;
	    ;
    break;}
case 269:
#line 1802 "parser.y"
{
		EmitCode (FloorOp);
		yyval.i = yyvsp[-1].i + 1;
	    ;
    break;}
case 270:
#line 1808 "parser.y"
{
		EmitCode (CeilOp);
		yyval.i = yyvsp[-1].i + 1;
	    ;
    break;}
case 271:
#line 1814 "parser.y"
{
		EmitCode (FmodOp);
		yyval.i = yyvsp[-3].i + yyvsp[-1].i + 1;
	    ;
    break;}
case 272:
#line 1820 "parser.y"
{
		EmitCode (FabsOp);
		yyval.i = yyvsp[-1].i + 1;
	    ;
    break;}
case 273:
#line 1829 "parser.y"
{
		EmitCode (JzOp, 0);
		yyval.i = 2;
	    ;
    break;}
case 274:
#line 1838 "parser.y"
{
		EmitCode (JmpOp, 0);
		yyval.i = 2;
	    ;
    break;}
case 275:
#line 1847 "parser.y"
{
		EmitCode (CopyOp);
		EmitCode (JnzOp, 0);
		EmitCode (PopOp);
		yyval.i = 4;
	    ;
    break;}
case 276:
#line 1858 "parser.y"
{
		EmitCode (CopyOp);
		EmitCode (JzOp, 0);
		EmitCode (PopOp);
		yyval.i = 4;
	    ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 465 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 1866 "parser.y"


# ifdef YYBYACC
char *felt_suppress_warnings_from_gcc = yysccsid;
# endif
