/*
    This file is part of the FElt finite element analysis package.
    Copyright (C) 1993-1995 Jason I. Gobat and Darren C. Atkinson

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

# ifndef _COLORMAP_H
# define _COLORMAP_H

static struct {
   unsigned short	r;
   unsigned short	g;
   unsigned short	b;
} color_values [ ] = {
      { 40960 ,     0 , 40960 },
      { 37632 ,     0 , 40960 },
      { 34048 ,     0 , 40960 },
      { 30464 ,     0 , 40960 },
      { 26880 ,     0 , 40960 },
      { 23296 ,     0 , 40960 },
      { 19712 ,     0 , 40960 },
      { 16128 ,     0 , 40960 },
      { 12544 ,     0 , 40960 },
      {  8960 ,     0 , 40960 },
      {  5376 ,     0 , 40960 },
      {  1792 ,     0 , 40960 },
      {     0 ,     0 , 41984 },
      {     0 ,     0 , 44032 },
      {     0 ,     0 , 46080 },
      {     0 ,     0 , 48128 },
      {     0 ,     0 , 50432 },
      {     0 ,     0 , 52480 },
      {     0 ,     0 , 54528 },
      {     0 ,     0 , 56576 },
      {     0 ,     0 , 58880 },
      {     0 ,     0 , 60928 },
      {     0 ,     0 , 62976 },
      {     0 ,     0 , 65280 },
      {     0 ,  2560 , 65280 },
      {     0 ,  5120 , 65280 },
      {     0 ,  7680 , 65280 },
      {     0 , 10240 , 65280 },
      {     0 , 13056 , 65280 },
      {     0 , 15616 , 65280 },
      {     0 , 18176 , 65280 },
      {     0 , 20736 , 65280 },
      {     0 , 23296 , 65280 },
      {     0 , 26112 , 65280 },
      {     0 , 28672 , 65280 },
      {     0 , 31232 , 65280 },
      {     0 , 33792 , 65280 },
      {     0 , 36352 , 65280 },
      {     0 , 39168 , 65280 },
      {     0 , 41728 , 65280 },
      {     0 , 44288 , 65280 },
      {     0 , 46848 , 65280 },
      {     0 , 49408 , 65280 },
      {     0 , 52224 , 65280 },
      {     0 , 54784 , 65280 },
      {     0 , 57344 , 65280 },
      {     0 , 59904 , 65280 },
      {     0 , 62464 , 65280 },
      {     0 , 65280 , 65280 },
      {     0 , 65280 , 62668 },
      {     0 , 65280 , 60057 },
      {     0 , 65280 , 57446 },
      {     0 , 65280 , 54835 },
      {     0 , 65280 , 52224 },
      {     0 , 65280 , 49612 },
      {     0 , 65280 , 47001 },
      {     0 , 65280 , 44390 },
      {     0 , 65280 , 41779 },
      {     0 , 65280 , 39168 },
      {     0 , 65280 , 36556 },
      {     0 , 65280 , 33945 },
      {     0 , 65280 , 31334 },
      {     0 , 65280 , 28723 },
      {     0 , 65280 , 26112 },
      {     0 , 65280 , 23500 },
      {     0 , 65280 , 20889 },
      {     0 , 65280 , 18278 },
      {     0 , 65280 , 15667 },
      {     0 , 65280 , 13056 },
      {     0 , 65280 , 10444 },
      {     0 , 65280 ,  7833 },
      {     0 , 65280 ,  5222 },
      {     0 , 65280 ,  2611 },
      {     0 , 65280 ,     0 },
      {  2611 , 65280 ,     0 },
      {  5222 , 65280 ,     0 },
      {  7833 , 65280 ,     0 },
      { 10444 , 65280 ,     0 },
      { 13056 , 65280 ,     0 },
      { 15667 , 65280 ,     0 },
      { 18278 , 65280 ,     0 },
      { 20889 , 65280 ,     0 },
      { 23500 , 65280 ,     0 },
      { 26112 , 65280 ,     0 },
      { 28723 , 65280 ,     0 },
      { 31334 , 65280 ,     0 },
      { 33945 , 65280 ,     0 },
      { 36556 , 65280 ,     0 },
      { 39168 , 65280 ,     0 },
      { 41779 , 65280 ,     0 },
      { 44390 , 65280 ,     0 },
      { 47001 , 65280 ,     0 },
      { 49612 , 65280 ,     0 },
      { 52224 , 65280 ,     0 },
      { 54835 , 65280 ,     0 },
      { 57446 , 65280 ,     0 },
      { 60057 , 65280 ,     0 },
      { 62668 , 65280 ,     0 },
      { 65280 , 65280 ,     0 },
      { 65280 , 62720 ,     0 },
      { 65280 , 60160 ,     0 },
      { 65280 , 57600 ,     0 },
      { 65280 , 55040 ,     0 },
      { 65280 , 52224 ,     0 },
      { 65280 , 49664 ,     0 },
      { 65280 , 47104 ,     0 },
      { 65280 , 44544 ,     0 },
      { 65280 , 41984 ,     0 },
      { 65280 , 39168 ,     0 },
      { 65280 , 36608 ,     0 },
      { 65280 , 34048 ,     0 },
      { 65280 , 31488 ,     0 },
      { 65280 , 28928 ,     0 },
      { 65280 , 26112 ,     0 },
      { 65280 , 23552 ,     0 },
      { 65280 , 20992 ,     0 },
      { 65280 , 18432 ,     0 },
      { 65280 , 15872 ,     0 },
      { 65280 , 13056 ,     0 },
      { 65280 , 10496 ,     0 },
      { 65280 ,  7936 ,     0 },
      { 65280 ,  5376 ,     0 },
      { 65280 ,  2816 ,     0 },
      { 65280 ,     0 ,     0 },
      { 62720 ,     0 ,     0 },
      { 60160 ,     0 ,     0 },
      { 57600 ,     0 ,     0 },
      { 55040 ,     0 ,     0 },
};

# endif /* _COLORMAP_H */
